routes/web.php
<?php
Route::get('/user', function () {
    return Auth()->user();
});

// Home Routes
Route::prefix('/')->namespace('Web\Home')->group(function () {
    Route::get('/', 'HomeController@index')->name('home');
    Route::get('articles', 'ArticleController@index')->name('articles.index');
    Route::get('articles/details/{article}', 'ArticleController@show')->where('article', '[0-9]+')->name('articles.show');
    Route::get('articles/details/{slug}', 'ArticleController@showBySlug')->name('articles.show-by-slug');
    Route::get('categories/{category}', 'CategoryController@show')->name('categories.show');
    Route::get('videos', 'VideoController@index')->name('videos.index');
    Route::get('videos/details/{video}', 'VideoController@show')->name('videos.show');
    Route::get('podcasts', 'PodcastController@index')->name('podcasts.index');
    Route::post('comments', 'CommentController@store')->name('comments.store');
    Route::post('comments/{comment}/reply', 'CommentController@reply_store')->name('comments.reply.store');
    Route::get('authors', 'AuthorController@index')->name('authors.index');
    Route::get('authors/{author}', 'AuthorController@show')->name('authors.show');
    Route::get('translators', 'TranslatorController@index')->name('translators.index');
    Route::get('translators/{translator}', 'TranslatorController@show')->name('translators.show');
    Route::get('socials', 'HomeController@socials')->name('socials');
    Route::get('post_box', 'HomeController@post_box')->name('post_box');
    Route::post('post_box', 'HomeController@post_box_store')->name('post_box.store');
    Route::get('search', 'SearchController@index')->name('search.index');
    Route::get('search/result', 'SearchController@search')->name('search.result');
});

// Admin Routes
Route::prefix('admin')->namespace('Web\Admin')->group(function () {
    // Admin Auth Routes
    Route::prefix('auth')->namespace('Auth')->group(function () {
        Route::get('/', 'LoginController@showLoginForm');
        Route::get('/login', 'LoginController@showLoginForm')->name('admin.login');
        Route::post('/login', 'LoginController@login');
        Route::post('/logout', 'LoginController@logout')->name('admin.logout');

        Route::post('/password/email', 'ForgotPasswordController@sendResetLinkEmail')->name('admin.password.request');
        Route::post('/password/reset', 'ResetPasswordController@reset')->name('admin.password.email');
        Route::get('/password/reset', 'ForgotPasswordController@showLinkRequestForm')->name('admin.password.reset');
        Route::get('/password/reset/{token}', 'ResetPasswordController@showResetForm');
    });

    Route::get('/login', function () {
        return redirect('admin/auth/login');
    });
    Route::get('/', function () {
        return redirect('admin/dashboard');
    });

    // Admin Dashboard Routes
    Route::prefix('/')->middleware('auth')->group(function () {
        Route::get('dashboard', 'DashboardController@index')->name('admin.dashboard');
        Route::post('articles/uploadimage', 'ArticleController@uploadimage');
        Route::resource('articles', 'ArticleController', ['as' => 'admin']);
        Route::resource('authors', 'AuthorController', ['as' => 'admin']);
        Route::resource('translators', 'TranslatorController', ['as' => 'admin']);
        Route::resource('categories', 'CategoryController', ['as' => 'admin']);
        Route::resource('tags', 'TagController', ['as' => 'admin']);
        Route::get('post_requests', 'PostRequestsController@index')->name('admin.post_requests.index');
        Route::get('post_requests/{post_request}', 'PostRequestsController@show')->name('admin.post_requests.show');
    });
});

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Category extends Model
{
    protected $fillable = array("name", "id", "slug", "status");

    public function getStatusAttribute($attribute)
    {
        return $this->statusOptions()[$attribute];
    }

    public function scopeActive($query)
    {
        return $query->where('status', 1);
    }

    public function scopeInactive($query)
    {
        return $query->where('status', 0);
    }

    public function statusOptions()
    {
        return [
            1 => 'Active',
            0 => 'Inactive'
        ];
    }
    public function posts()
    {
        return $this->belongsToMany(Post::class);
    }

    public function publishedPosts()
    {
        return $this->belongsToMany(Post::class)->published();
    }
}

app/Http/Controllers/Web/Admin/CategoryController.php
<?php

namespace App\Http\Controllers\Web\Admin;

use App\Models\Category;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Session;


class CategoryController extends Controller
{
    public function index()
    {
        $data = array(
            'categories' => Category::orderBy('id', 'desc')->get()
        );
        return view('admin.categories.index', $data);
    }

    public function create()
    {
        $data = array();
        return view('admin.categories.create', $data);
    }

    public function store(Request $request)
    {
        $validated = $request->validate([
            'name' => 'required',
        ]);

        if ($validated == true) {
            $categories = new Category();
            $categories->name = $request->name;
            $categories->slug = str_slug($request->name);
            $categories->status = $request->status;

            if ($categories->save()) {
                Session::flash('response', array('type' => 'success', 'message' => 'Category added successfully!'));
            } else {
                Session::flash('response', array('type' => 'error', 'message' => 'Something Went wrong!'));
            }
            return redirect('admin/categories');
        } else {
            Session::flash('response', array('type' => 'error', 'message' => 'Data not valid!'));
            return redirect('admin/categories/create');
        }
    }

    public function show(Category $category)
    {
        //
    }

    public function edit(Category $category)
    {
        $data = array(
            'category' => Category::find($category->id)
        );
        return view('admin/categories/edit', $data);
    }

    public function update(Request $request, $id)
    {
        $categories = Category::find($id);
        $categories->name = $request->name;
        $categories->status = $request->status;
        $categories->save();

        if ($categories->save()) {
            Session::flash('response', array('type' => 'success', 'message' => 'categories Updated successfully!'));
        } else {
            Session::flash('response', array('type' => 'error', 'message' => 'Something Went wrong!'));
        }
        return redirect('admin/categories');
    }

    public function destroy(Category $category)
    {
        if ($category->delete()) {
            Session::flash('response', array('type' => 'success', 'message' => 'Category deleted successfully!'));
        } else {
            Session::flash('response', array('type' => 'error', 'message' => 'Something Went wrong!'));
        }
        return redirect('admin/categories');
    }
}

app/Http/Controllers/Web/Home/CategoryController.php
<?php

namespace App\Http\Controllers\Web\Home;

use App\Models\Category;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

class CategoryController extends Controller
{
    public function index()
    {
        //
    }

    public function show(Category $category)
    {
        $data = array(
            'category' => Category::find($category->id),
            'posts' => Category::with('publishedPosts.authors', 'publishedPosts.tags', 'publishedPosts.translators')->find($category->id)->publishedPosts
        );
        return view('home.categories.show', $data);
    }
}

resources/views/admin/categories/create.blade.php
@extends('layouts.admin')
@section('title', 'Add Category')
@section('second-nav-bar')
<ul class="right hide-on-med-and-down">
    <li>
        <a href="{{url('admin/categories/create')}}">Add Category</a>
    </li>
</ul>
<ul id="nav-mobile" class="sidenav">
    <li>
        <a href="{{url('admin/categories/create')}}">Add Category</a>
    </li>
</ul>
<a href="#" data-target="nav-mobile" class="sidenav-trigger">
    <i class="material-icons">menu</i>
</a>
@endsection
@section('content')
<div class="card panel">
    <div class="panel-header">
        <span class="panel-title">Add New Category</span>
        <div class="actions">
            <a href="{{ url('admin/categories') }}" class="btn-flat">
                <i class="material-icons">close</i>
            </a>
        </div>
    </div>
    <div class="card-content">
        <div class="row">
            <form action="{{ route('admin.categories.store')}}" method="POST" enctype="multipart/form-data">
                @csrf
                <div class="col s9 pr-2">
                    <div class="row">
                        <div class="input-field outline col s12">
                            <input name="name" id="name" type="text" class="@error('name') invalid @enderror" required
                                autofocus>
                            <label for="name">{{ __('Category Name') }}</label>
                            @error('name')
                            <span class="helper-text red-text">{{ $message }}</span>
                            @enderror
                        </div>
                    </div>
                </div>

                <div class="col s9 pr-2">
                    <div class="row">
                        <div class="input-field outline col s12">
                            <select class="" name="status" id="status" required>
                                <option value="1">Active</option>
                                <option value="0">Inactive</option>
                            </select>
                            <label for="status">Status</label>
                        </div>
                    </div>
                </div>

                <div class="input-field col s12">
                    <button class="btn custom teal waves-effect waves-light" type="submit" name="action">
                        <i class="material-icons left">add</i> Add Category
                    </button>
                </div>
            </form>
        </div>
    </div>
</div>
@endsection

resources/views/admin/categories/edit.blade.php
@extends('layouts.admin')
@section('title', 'Edit Category')
@section('second-nav-bar')
<ul class="right hide-on-med-and-down">
    <li>
        <a href="{{url('admin/categories/create')}}">Add Category</a>
    </li>
</ul>
<ul id="nav-mobile" class="sidenav">
    <li>
        <a href="{{url('admin/categories/create')}}">Add Category</a>
    </li>
</ul>
<a href="#" data-target="nav-mobile" class="sidenav-trigger">
    <i class="material-icons">menu</i>
</a>
@endsection
@section('content')
<div class="card panel">
    <div class="panel-header">
        <span class="panel-title">Edit Category</span>
        <div class="actions">
            <a href="{{ url('admin/categories') }}" class="btn-flat">
                <i class="material-icons">close</i>
            </a>
        </div>
    </div>
    <div class="card-content">
        <div class="row">
            <form action="{{ route('admin.categories.update', $category['id']) }}" method="POST"
                enctype="multipart/form-data">
                <input name="_method" type="hidden" value="PATCH">
                @csrf
                <div class="col s9 pr-2">
                    <div class="row">
                        <div class="input-field outline col s12">
                            <input name="name" id="name" type="text" class="@error('name') invalid @enderror"
                                value="{{ $category->name }}" autofocus>

                            @error('name')
                            <span class="helper-text red-text">{{ $message }}</span>
                            @enderror
                        </div>
                    </div>
                </div>

                <div class="col s9 pr-2">
                    <div class="row">
                        <div class="form-group">
                            <label for="status">Status</label>
                            <select class="form-control" name="status" id="status" required>
                                <option value="1" @if($category->status == 1) {{ 'selected' }} @endif>Active</option>
                                <option value="0" @if($category->status == 0) {{ 'selected' }} @endif>Inactive</option>
                            </select>
                        </div>
                    </div>
                </div>

                <div class="input-field col s12">
                    <button class="btn custom teal waves-effect waves-light" type="submit" name="action">
                        <i class="material-icons left">add</i> Update Category
                    </button>
                </div>
            </form>
        </div>
    </div>
</div>
@endsection

resources/views/admin/categories/index.blade.php
@extends('layouts.admin')
@section('title', 'Categories')
@section('second-nav-bar')
<ul class="right hide-on-med-and-down">
    <li>
        <a href="{{ url('admin/categories/create') }}">Add Category</a>
    </li>
</ul>
<ul id="nav-mobile" class="sidenav">
    <li>
        <a href="{{ url('admin/categories/create') }}">Add Category</a>
    </li>
</ul>
<a href="#" data-target="nav-mobile" class="sidenav-trigger">
    <i class="material-icons">menu</i>
</a>
@endsection
@section('content')
<div class="card material-data-table">
    <div class="table-header">
        <span class="table-title">All Categories</span>
        <div class="actions">
            <a href="{{ route('admin.categories.create') }}" class="btn-flat">
                <i class="material-icons">add</i>
            </a>
            <a href="JavaScript:Void(0);" class="search-toggle waves-effect btn-flat">
                <i class="material-icons">search</i>
            </a>
        </div>
    </div>
    <table class="datatable responsive-table">
        <thead>
            <tr>
                <th class="hide">{{ _('#') }}</th>
                <th>{{ _('Name') }}</th>
                <th>{{ _('Status') }}</th>
                <th>{{ _('Created At') }}</th>
                <th>{{ _('Action') }}</th>
            </tr>
        </thead>
        <tbody>
            @foreach ($categories as $index => $category)
            <tr>
                <td class="hide">{{ $index + 1 }}</td>
                <td>{{ $category->name }}</td>
                <td>{{ $category->status }}</td>
                <td>{{date('d M, Y', strtotime($category->created_at))}}</td>
                <td>
                    <a href="{{ route('categories.show', $category->id) }}" target="_blank"
                        class="btn-floating btn-flat btn-small waves-effect waves-light teal mr-3">
                        <i class="material-icons">visibility</i></a>
                    <a href="{{ route('admin.categories.edit', $category->id) }}"
                        class="btn-floating btn-flat btn-small waves-effect waves-light teal mr-3">
                        <i class="material-icons">edit</i></a>
                    <form action="{{ route('admin.categories.destroy', $category->id) }}" method="POST"
                        style="display: inline-block;">
                        @csrf
                        @method('DELETE')
                        <button type="submit" class="btn-floating btn-flat btn-small waves-effect waves-light red"
                            onclick="return(confirm('Are you sure to delete?'))"><i
                                class="material-icons">delete</i></button>
                    </form>
                </td>
            </tr>
            @endforeach
        </tbody>
    </table>
</div>
@endsection